﻿using System.Runtime.InteropServices.JavaScript;
using System.Runtime.Versioning;

namespace SimpleVoiceChat.BlazorWasm
{
    [SupportedOSPlatform("browser")]
    public static partial class SvcModule
    {
        public static Action OnInit;
        public static Action<byte[]> ChunkArrive;

        private static JSObject _jsModule;


        public static async Task<bool> Init()
        {
            _jsModule ??= await JSHost.ImportAsync("SvcModule", "/svc-module.js");
            return await JsInit();
        }

        public static async Task Start()
        {
            await JsStart();
        }

        public static async Task Stop()
        {
            JsStop();
        }

        [JSImport("init", "SvcModule")]
        private static partial Task<bool> JsInit();

        [JSImport("start", "SvcModule")]
        private static partial Task JsStart();

        [JSImport("stop", "SvcModule")]
        private static partial void JsStop();

        [JSImport("createBlobUrl", "SvcModule")]
        public static partial Task<string> CreateBlob(byte[] data);

        [JSExport]
        private static void JsFeedChunk(byte[] chunk)
        {
            Console.WriteLine("chunk");
            if (ChunkArrive != null) ChunkArrive(chunk);

        }

        [JSExport]
        private static void JsInitCallBack(bool value)
        {
            if (OnInit != null) OnInit();
        }
    }
}
