﻿using Newtonsoft.Json;

internal class ConfigFile
{
    static ConfigFile() => Reload();

    public static void Reload() => Instance = JsonConvert.DeserializeObject<ConfigFile>(File.ReadAllText(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "config.json")));

    public static ConfigFile Instance { get; private set; }

    public string ListenPrefix { get; set; }
    public IReadOnlyDictionary<string, ModuleEntry> Modules { get; set; }
    public string Title { get; set; }
    public string AdminPassword { get; set; }
    public int HistoryMessageLength { get; set; }
}
